from .models import *
from django.db import IntegrityError


def evaluate(responses, otherData):
    #create evaluation object
    evalObj = Evaluation()
    if len(responses) == 0:
        return

    # attemptObj = Attempt()
    # attempt.student = Student.objects.get(username=request.session['username'])
    # attemptObj.test = responses[0].test_ID
    # attemptObj.save()
    evalObj.student_id = otherData['username']
    evalObj.test_ID_id = int(otherData['testID'])
    

    # evalObj.attempt = attemptObj
    evalObj.q_ID = None
    correctAnswer = None
    for response in responses:
        (question, options), = response.items()
        question = int(question)
        # options = responses[question]
        if evalObj.q_ID_id != int(question): # otherwise you have the answer already
            evalObj.q_ID_id = question
            correctAnswer = Options.objects.filter(q_ID_id = question, is_Answer = True).values('pk')    
            correctAnswer = list(correctAnswer.values('pk')) 
            correctAnswer = list(map(lambda x: x['pk'], correctAnswer))
        # if correctAnswer == Responses.objects.filter(q_ID = response.q_ID, 
        # student_ID = Student.objects.get(username=request.session['username']),
        # test_ID = responses[0].test_ID):
        #     evalObj.marks = 1

        responseList = options
        # print "correctanswer"
        # print correctAnswer
        # print correctAnswer.values('pk')
        # correctAnswer = list(correctAnswer.values('pk'))
        # correctAnswer = list(map(lambda x: x['pk'], correctAnswer))
        print correctAnswer
        if len(responseList) == len(correctAnswer) and sorted(responseList) == sorted(correctAnswer):
            evalObj.marks = 1
        # print "responses"
        # print responseList
        # print correctAnswer
        # print evalObj
        try:
            evalObj.save()
        except IntegrityError as e:
            print "Integrity error - evaluation not recorded"
            pass
        
